<template>
  <section class="section">
    <div class="container">
      <div class="columns is-centered">
        <div class="column is-one-third">
          <h1 class="title">Feeds</h1>
          <hr />
          <ApolloQuery
            :query="require('../graphql/Image/AllImages.gql')">
            <ApolloSubscribeToMore
              :document="require('../graphql/Image/ImageAdded.gql')"
              :updateQuery="onImageAdded"
            />
            <div slot-scope="{ result: { data } }">
              <template v-if="data">
                <FeedItem v-for="image in data.allImages" :key="image.id" :image="image" />
              </template>
            </div>
          </ApolloQuery>
        </div>
      </div>
    </div>
  </section>
</template>

<script>
import FeedItem from '@/components/Feed/FeedItem'
export default {
  name: 'feed',
  components: { FeedItem },
  methods: {
    onImageAdded (previousResult, { subscriptionData }) {
      const newResult = {
        allImages: [...previousResult.allImages]
      }
      newResult.allImages.unshift(subscriptionData.data.Image.node)
      return newResult
    }
  }
}
</script>
